<?php

if (sfConfig::get('app_sfGalleryPlugin_routes_register', true) && in_array('sfGallery', sfConfig::get('sf_enabled_modules')))
{
  $r = sfRouting::getInstance();

  // preprend our routes
  $r->prependRoute('sf_profile_image', '/user/setphoto/:id', array('module' => 'sfGallery', 'action' => 'setProfileImage'), array('id' => '\d+'));
  $r->prependRoute('sf_userphotos', '/user/:id/photos/', array('module' => 'sfGallery', 'action' => 'photosByUserId'), array('id' => '\w+'));
  $r->prependRoute('sf_photos', '/photos/*', array('module' => 'sfGallery', 'action' => 'browsePhotos'));
  $r->prependRoute('sf_gallery', '/gallery/:id', array('module' => 'sfGallery', 'action' => 'show'), array('id' => '\d+'));
  $r->prependRoute('sf_photo', '/photo/:id', array('module' => 'sfGallery', 'action' => 'photo'), array('id' => '\d+'));
  $r->prependRoute('sf_new_gallery', '/user/gallery/new', array('module' => 'sfGallery', 'action' => 'addGallery'));
  $r->prependRoute('sf_create_gallery', '/user/gallery/create', array('module' => 'sfGallery', 'action' => 'createGallery'));
  $r->prependRoute('sf_new_photo', '/user/photo/new/:id', array('module' => 'sfGallery', 'action' => 'addPhoto'), array('id' => '\d+'));
  $r->prependRoute('sf_create_photo', '/user/photo/create', array('module' => 'sfGallery', 'action' => 'createPhoto'));
  $r->prependRoute('sf_thumbnail_photo', '/user/gallery/thumbnail/:id', array('module' => 'sfGallery', 'action' => 'setThumbnail'), array('id' => '\d+'));
  $r->prependRoute('sf_delete_photo', '/user/photo/delete/:id', array('module' => 'sfGallery', 'action' => 'deletePhoto'), array('id' => '\d+'));
}
