<?php

/**
 * Subclass for performing query and update operations on the 'sf_gallery' table.
 *
 * 
 *
 * @package lib.model
 */ 
class sfGalleryPeer extends BasesfGalleryPeer
{

  static public function getListByUserId($user_id, $page = 1) {
    $c = new Criteria();
    if ($user_id) 
      $c->add(sfGalleryPeer::USER_ID, $user_id);
    $g = sfGalleryPeer::doSelectWidthPager($c, $page);
    return $g;
  }

  public static function doSelectWidthPager(Criteria $criteria, $npage, $con = null)
  {
    $pager = new sfPropelPager('sfGallery', 10);
    $pager->setCriteria($criteria);
    $pager->setPage($npage);
    $pager->setPeerMethod('doSelect');
    $pager->init();
    return $pager;
  } 

}
