<?php

  /**
   * Returns an image url to use the images thumbnail
   * 
   */
  function gallery_thumbnail($gallery, $photo) {
    if ($photo) {
      $p = sfPhotoPeer::retrieveByPK($photo);
      $filename = $p->getFilename();
      return image_tag("/uploads/gallery/$gallery/thumbs/$filename");
    } else return image_tag("/uploads/gallery/default.jpg");
  }

  /**
   * Returns an image url to use the images thumbnail
   * 
   */
  function image_thumbnail($photo_id) {
    $p = sfPhotoPeer::retrieveByPK($photo_id);

    if ($p)
	    return link_to(image_tag("/uploads/gallery/".strtolower($p->getsfGallery())."/thumbs/".$p->getFilename()), 'sfGallery/photo?id='.$photo_id);
    else 
			return false;
  }

  /**
   * Returns an image url
   * 
   */
  function gallery_image($gallery, $photo, $options = '') {
    return image_tag("/uploads/gallery/$gallery/$photo", $options);
  }

  /**
   * Returns an photos number
   * 
   */
  function photos_cnt($gallery_id) {
    $c = new Criteria();
    $c->add(sfPhotoPeer::GALLERY_ID, $gallery_id);
    $cnt = sfPhotoPeer::doCount($c);

    return "$cnt photos";
  }             
 
?>