<?php use_helper('sfGallery', 'sfGuardUserPlus') ?>

<h1>Browse photos</h1>

<ul id="sf_photos">
<?php foreach ($elements->getResults() as $e): ?>

  <li>
    <?php echo image_thumbnail($e->getId()) ?>
  </li>

<? endforeach; ?>
</ul>

<div id="gallery_pager">
<?php if ($elements->haveToPaginate()): ?>
  <?php echo link_to('&laquo;', 'sfGallery/browsePhotos?page=1') ?>
  <?php echo link_to('&lt;', 'sfGallery/browsePhotos?page='.$elements->getPreviousPage()) ?>
 
  <?php foreach ($elements->getLinks() as $page): ?>
    <?php echo link_to_unless($page == $elements->getPage(), $page, 'sfGallery/browsePhotos?page='.$page) ?>
    <?php echo ($page != $elements->getCurrentMaxLink()) ? '-' : '' ?>
  <?php endforeach; ?>
 
  <?php echo link_to('&gt;', 'sfGallery/browsePhotos?page='.$elements->getNextPage()) ?>
  <?php echo link_to('&raquo;', 'sfGallery/browsePhotos?page='.$elements->getLastPage()) ?>
<?php endif; ?>
</div>